<?php
/*
 * the home page
 */
require_once("include_main.php");
InputPage::$method = "post";

function read_pg_ips($appName, &$error) {
    global $mainSession;

    //exec("/sbin/ifconfig eth0 | grep inet | awk '{print $2}' | sed -e 's/Adresse://' -e 's/addr://'",$serverAddr);
    //if(!$serverAddr[0]) return;
    exec("cat ".Config::pgHba." | egrep -ve '(127.0.0.1)'",$content);
    if(!$content) {
        $error = tl::tlx('Could not read file \'{$arg[1]}\'.', Config::pgHba);
        return false;
    }
    $matches = array();
    $ips = array();
    foreach($content as $line) {
        if(strpos($line, "#") !==0 && preg_match("/.*host.*{$appName}.*{$appName}[ \t]+((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?))\/[0-9]{2}.*md5.*/", $line, $matches)) {
            $ips[] = $matches[1];
        }
    }
    return $ips;
}

// a PostgreSQL database connector
class PostgreSQLLink {
    var $db = null;
    var $isOpen = false;
    
    public function PostgreSQLLink($host, $user, $pw, $port, $db) {
        
        $this->db = @pg_connect("host=$host port=$port dbname=$db user=$user password='$pw' sslmode=disable");
        $this->isOpen = ($this->db !== false) ;
        $query = "set client_encoding to 'UTF8'";
        if(@pg_query($this->db, $query) === false) {
            // error handling, if wished
        }
    }
    
    public function close() {
        if($this->isOpen) {
            $c = pg_close($this->db);
            $this->isOpen = false;
            $this->db = null;
        }
    }    
}

// the inno-web license2 database
class DbPGSql extends PostgreSQLLink {
    const ip = "127.0.0.1";
    const port = 5432;
    var $database = "";
    var $user = "";
    var $pw = "";
    var $diePage = "";
    
    public function getConnString() {
        $connString = "host = ".self::ip." port = ".self::port." dbname = {$this->database} user = {$this->user} password = '{$this->pw}' sslmode = disable";

        return $connString;
    }
    
    public function DbPGSql($database, $user, $pw, $diePage) {
        $this->database = $database;
        $this->user = $user;
        $this->pw = $pw;
        $this->diePage = $diePage;
        
        $this->PostgreSQLLink(self::ip, $user, $pw, self::port, $database);
    }
    
    public function run($query) {
        check_query($query, $this->diePage);
        $result = @pg_query($this->db, $query);
        if(!$result) {
            // error handling, if wished
        }
        return $result;
    }
}

function check_query($query, $diePage) {
    if((stripos($query, "update") === 0 || stripos($query, "delete") === 0) && stripos($query, "where") === false) {
        home_die("update/delete query contains no where condition", $diePage);
        exit;
    }
}

class ButtonChangePgPassword extends MainInputPageOkCancelButton {
    var $mode;
    var $appName;
    var $pageConfig;

    public function ButtonChangePgPassword($name, $pageNo, InputPage &$page, $mode, $appName, $pageConfig) {
        parent::__construct($name, $pageNo, $page);
        $this->mode = $mode;
        $this->pageConfig = $pageConfig;
        $this->appName = $appName;
    }
    
    function action(InputPage &$page, $phase) {
        $error = false;
        $currPw = $page->getField("currentpw");
        $newPw = $page->getField("newpw");
        $verPw = $page->getField("verpw");
        if(!$newPw->valid() || !$verPw->valid() || !$currPw->valid()) {
            return $this->error($page, "");
        }
        $error = MainMethods::checkRunningScript(Config::configErrorPostgres);
        // fields shown in the green field under the tab menu
        if($error != "") {
            return $error;
        } else {
            $cmd = "/usr/bin/sudo /usr/local/bin/config.sh postgres check-pwd \"{$currPw->value}\" \"{$this->appName}\"";
            $chkPass = main_system($cmd, $retval);
            if($chkPass != "" || $retval != "") {
                return $this->error($page, tl::tl('Current password does not match.'));
            } else {
                $cmd = "/usr/bin/sudo /usr/local/bin/config.sh postgres password \"{$newPw->value}\" \"{$this->appName}\"";
                $resPass = main_system($cmd, $retval);
                if($resPass != "" || $retval != "")
                    return $this->error($page, tl::tlx('New password could not be set: {$arg[1]}.', $resPass));
            }
        }
        $page->warp($_SERVER["SCRIPT_NAME"]."?_page={$this->pageConfig}&".$page->getArgs()."&pwchanged=1");
    }
    
    function error(InputPage &$page, $error) {
        $this->msg = $error;
        $page->render();
    }
}

class ButtonAddDbIp extends InputPageAction {
    var $appName;
    var $pageConfig;
    
    public function ButtonAddDbIp($name, $value, $appName, $pageConfig) {
        parent::__construct($name, $value);
        $this->autorender = false;
        $this->pageConfig = $pageConfig;
        $this->appName = $appName;
    }

    function action(InputPage &$page, $phase) {
        $ip = $page->getField("ip");
        if(!$ip->valid()) {
            $page->render();
            return;
        }
        //check if IP exists
        $list = $page->getField("iplist");
        foreach($list->value as $value) {
            if($value[$list->name."ip"] == $ip->value) {
                return $this->error($page, tl::tl("IP address already in list."));
            }
        }
        $error = "";
        if(self::ip($ip->value, true, $this->appName, $error) === false) {
            return $this->error($page, $error);
        }
        
        $page->warp($_SERVER["SCRIPT_NAME"]."?_page={$this->pageConfig}&".$page->getArgs()."&ipadded=1");
    }
    
    static function ip($ip, $add, $appName, &$error) {
        $error = MainMethods::checkRunningScript(Config::configErrorPostgres);
        // fields shown in the green field under the tab menu
        if($error != "") {
            return false;
        } else {
            $ipCmd = $add === true ? "add-ip" : "delete-ip";
            $cmd = "/usr/bin/sudo /usr/local/bin/config.sh postgres $ipCmd $appName $appName $ip";
            $resAddIp = main_system($cmd, $retval);
            if($retval != "" || $resAddIp != "") {
                $error = $resAddIp;
                return false;
            }
        }
        return true;
    }
     
    function error(InputPage &$page, $error) {
        $ip = $page->getField("ip");
        $ip->msg = $error;
        $page->render();
    }
}

class ButtonDeleteDbIp extends InputPageButtonOnlyAction {
    var $pageConfig;
    var $appName;
    
    public function ButtonDeleteDbIp($name, $value, $appName, $pageConfig) {
        parent::__construct($name, $value);
        $this->appName = $appName;
        $this->pageConfig = $pageConfig;
    }

    function action(InputPage &$page, $phase) {
        $list = $page->getField("iplist");
        $ipsToDelete = array();
        foreach($list->value as $value) {
            if($value[$list->name."chkdelete"]["on"]) {
                $ipsToDelete[count($ipsToDelete)] = $value[$list->name."ip"];
            }
        }
        if(count($ipsToDelete) == 0) {
            return $this->error($page, "");
        } else {
            $error = "";
            foreach($ipsToDelete as $ipDel) {
                if(ButtonAddDbIp::ip($ipDel, false, $this->appName, $error) === false) {
                    return $this->error($page, $error);
                }
            }
        }
        $page->warp($_SERVER["SCRIPT_NAME"]."?_page={$this->pageConfig}&".$page->getArgs()."&ipdeleted=1");
    }

    function error(InputPage &$page, $error) {
        $this->msg = $error;
        $page->render();
    }
}

abstract class PostgresPage extends MyPage {
    const modeInRePgPw = "inrepgpw", modeAskDeleteCdrs = "askdeletecdrs", modeDeleteCdrs = "deletecdrs", modePgIPs = "pgips",
            modeCDRCleanup = "cdrcleanup";
    
    public function tabPgSql($appName, $pageConfig, $modeStandby = "") {
        $this->currentSection = $this->parent->currentTab;
        $this->addActionText();
        $error = MainMethods::checkRunningScript(Config::configErrorPostgres);
        // fields shown in the green field under the tab menu
        if($error != "") {
            $running = $this->addField(new InputPageText("procrunning", $error));
            $running->fullline = true;
        } else {
            $text = tl::tlx('Change {$arg[1]} database password', $appName);
            $pgPw = $this->addField(new InputPageText("innovaphonepostgrespw", $this->getModeLink(self::modeInRePgPw, $text)));
            $pgPw->fullline = true;
            
            if($appName === "innovaphone-reporting") {
                $textDelCDRs = tl::tl("Delete CDRs from database");
                $delCDRs = $this->addField(new InputPageText("innovaphonereportingdeletecdrs", $this->getModeLink(self::modeAskDeleteCdrs, $textDelCDRs)));
                $delCDRs->fullline = true;
                $textCleanup = tl::tl("Configure scheduled CDR cleanup");
                $this->addField($cleanupCDRs = new InputPageText("innovaphonereportingcleanupcdrs", $this->getModeLink(self::modeCDRCleanup, $textCleanup)));
                $cleanupCDRs->fullline = true;
                global $reportingSession;
                if($reportingSession->reportingCfg->replication->mode == $modeStandby) {
                    $disabledText = tl::tl("innovaphone Reporting is running in standby mode, so CDRs can't be deleted.");
                    $delCDRs->value = disable_link($textDelCDRs, $disabledText);
                    $cleanupCDRs->value = disable_link($textCleanup, $disabledText);
                }
            }

            $textPgIPs = tl::tlx('Configure {$arg[1]} database access', $appName);
            $pgIps = $this->addField(new InputPageText("innovaphonepostgresips", $this->getModeLink(self::modePgIPs, $textPgIPs)));
            $pgIps->fullline = true;
            
            switch($this->parent->currentMode) {
                case self::modeInRePgPw:
                    $this->modePgPassword($appName, $text, $pageConfig);
                    break;
                case self::modePgIPs:
                    $this->modePgIPs($appName, $textPgIPs, $pageConfig);
                    break;
                case self::modeDeleteCdrs:
                case self::modeAskDeleteCdrs:
                    $this->modeAskDeleteCdrs($textDelCDRs);
                    $this->modeDeleteCdrs();
                    break;
                case self::modeCDRCleanup:
                    $this->modeCDRCleanup($textCleanup);
                    break;
            }
        }
    }
    
    public function modePgIPs($appName, $text, $pageConfig) {
        $this->currentSection = $this->parent->currentMode;
        $this->addSection($this->parent->currentMode, 1, true, $text);
        $ip = $this->addField(new InputPageText("addip", "<br>". tl::tlx('Add an IP address, which shall have access to the {$arg[1]} database', $appName)));
        $ipField = $this->addField(new InputPageIPField("ip", tl::tl("IP address")));
        $ipField->button = &$this->addField(new ButtonAddDbIp("buttonaddip", tl::tl("Ok"), $appName, $pageConfig ));
        $ipField->emptyOk = true;
        $ipField->attributes["onKeyDown"] = "javascript:submitButton(event, '{$ipField->button->name}')";

        $this->addField(new InputPageHorizontalRule());

        $list = $this->addField( new MainInputPageListField("iplist") );  // will be filled in fillList
        $list->fieldOnEmptyTable = new InputPageText($list->name."emptytable", "");
        // its columns
        $fld = $list->addColumn(new InputPageTextField($list->name."ip", null), tl::tl("IP address"));
        $chkName = $list->name."chkdelete";
        $chk = $list->addColumn(new InputPageCheckboxField($chkName, null), $this->parent->getUnCheckAllInput($chkName, false));

        $this->addField(new ButtonDeleteDbIp("buttondeleteip", tl::tl("Delete"), $appName, $pageConfig));
    }
    
    public function modePgPassword($appName, $text, $pageConfig) {
        $this->currentSection = $this->parent->currentMode;
        $this->addSection($this->parent->currentMode, 1, true, $text);
        $user = $this->addField(new InputPageStringField("user", tl::tl("User")));
        $user->attributes["readonly"] = "readonly";
        $user->default = $currentUser->default = $appName;
        $curPw = $this->addField(new InputPagePasswordField("currentpw", tl::tl("Current password")));
        $curPw->emptyOk = true;
        $newPw = $this->addField(new InputPagePasswordField("newpw", tl::tl("New password")));
        $newPw->emptyOk = true;
        $verPw = $this->addField(new InputPageRetypePasswordField($newPw, "verpw", tl::tl("Verify password")));
        $verPw->emptyOk = true;
        $curPw->minlength = $newPw->minlength = $verPw->minlength = 1;
        $btn = $this->addField(new ButtonChangePgPassword("buttonpostgrespassword", $pageConfig, $this->parent, $this->parent->currentMode, $appName, $pageConfig));
        $newPw->attributes["onKeyDown"] = $verPw->attributes["onKeyDown"] = "javascript:submitButton(event, '{$btn->name}', '{$btn->name}_cancel')";
    }
    
    public function fillIpList($appName) {
        $list = $this->parent->getField("iplist");
        if(!is_object($list)) return;
        $values = $list->value;
        $list->value = array();
        $return = false;
        if(($ips = read_pg_ips($appName, $error)) === false) {
            $list->fieldOnEmptyTable->value = "<div style=\"color:red\">$error</div>";
            $return = true;
        }
        else if(count($ips) == 0) {
            $list->fieldOnEmptyTable->value = "<b>".tl::tl("No IP addresses yet.")."</b>";
            $return = true;
        }
        if($return) {
            $buttonDelete = $this->parent->getField("buttondeleteip");
            $buttonDelete->autorender = false;
            return;
        }
        $rows = 0;
        $list->value = array();
        foreach($ips as $ip) {
            $list->value[$rows][$list->name."ip"] = $ip;    
            $rows++;
        }
        
        if(count($values)) {   // assign certain columns now with former values, given by parameter $values
            unset($val);
            foreach($list->value as &$val) {
                foreach($values as $value) {
                    if($value[$list->name."ip"] == $val[$list->name."ip"]) {
                        $val[$list->name."chkdelete"] = isset($value[$list->name."chkdelete"]) ? $value[$list->name."chkdelete"] : null;
                        break;
                    }
                }
            }
        }
    }
}
?>
